#include <cvirte.h>		
#include <userint.h>
#include "WvControl.h"
#include "WvFunc.h"
#include "WvControlFunc.h"


int panelHandle;

int main (int argc, char *argv[])
{
	if (InitCVIRTE (0, argv, 0) == 0)
		return -1;	/* out of memory */
	if ((panelHandle = LoadPanel (0, "WvControl.uir", PANEL)) < 0)
		return -1;
	DisplayPanel (panelHandle);
	RunUserInterface ();
	DiscardPanel (panelHandle);
	return 0;
}

int CVICALLBACK WvTable (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event)
	{
		case EVENT_COMMIT:
			break;
			
		case EVENT_EDIT_MODE_STATE_CHANGE:
			if(!eventData1){
				 CalculateTable();
			
			
			}
			break;
	}
	return 0;
}

int CVICALLBACK Reload (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event)
	{
		case EVENT_COMMIT:
			
			OpenFileF();
			//InitTable();
			LoadTable(); 
			break;
	}
	return 0;
}

int CVICALLBACK Insert (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event)
	{
		case EVENT_COMMIT:
			InsertTable();
			break;
	}
	return 0;
}

int CVICALLBACK Save (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event)
	{
		case EVENT_COMMIT:
			SaveTable();
			WriteFileF();
			break;
	}
	return 0;
}

int CVICALLBACK Exit (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event)
	{
		case EVENT_COMMIT:
			QuitUserInterface(0);
			break;
	}
	return 0;
}
