#include <userint.h>
#include "WvControlFunc.h"
#include "WvControl.h"
#include "WvFunc.h"

extern int panelHandle;
extern int CurrentSelectWV_FileIO;

extern int nWV_FileIO;
extern WvSet Data[50];

int LoadTable(void){
	int i;
	
	DeleteTableRows(panelHandle, PANEL_WVTABLE,1,-1);  
	for(i=0;i<nWV_FileIO;i++)
		{
			//fscanf(FP, "%d %f %d %f\r\n", &line_no, &Data[i].Wv, &Data[i].Step, &Data[i].Angle);
			//printf("%d - WV: %.2f, Step: %d, Angle: %.2f\n",k, Data[i].Wv, Data[i].Step, Data[i].Angle);
			InsertTableRows(panelHandle,PANEL_WVTABLE,-1, 1,0);
			SetTableCellAttribute(panelHandle,PANEL_WVTABLE, MakePoint( 1, i+1), ATTR_CTRL_VAL, Data[i].Wv);
			SetTableCellAttribute(panelHandle,PANEL_WVTABLE, MakePoint( 2, i+1), ATTR_CTRL_VAL, Data[i].Order); 
			SetTableCellAttribute(panelHandle,PANEL_WVTABLE, MakePoint( 3, i+1), ATTR_CTRL_VAL, Data[i].Angle); 
			SetTableCellAttribute(panelHandle,PANEL_WVTABLE, MakePoint( 4, i+1), ATTR_CTRL_VAL, Data[i].Step); 
		}

	return 1;
}
	

//this is for initialize, after that, This function is useless.
int InitTable(void){
			double angle;
			int step;
			Data[0].Step=-7610;  
			
			AngleStepCalculating(6562.8, 34, &angle, &step);  
			Data[0].Wv		=	6562.8;
			Data[0].Order	=	34;
			Data[0].Angle	=	angle;
			Data[0].Step	=	step;
			
			AngleStepCalculating(6562.8, 35, &angle, &step);  
			Data[1].Wv		=	6562.8;
			Data[1].Order	=	35;
			Data[1].Angle	=	angle;
			Data[1].Step	=	step;
			
			AngleStepCalculating(6562.8, 33, &angle, &step);  
			Data[2].Wv		=	6562.8;
			Data[2].Order	=	33;
			Data[2].Angle	=	angle;
			Data[2].Step	=	step;
			
			nWV_FileIO=3;
			
	return 1;
		
}


int InsertTable(void){
	int i;
	
	nWV_FileIO++;
	i=nWV_FileIO-1;
	InsertTableRows(panelHandle,PANEL_WVTABLE,-1, 1,0);
	SetTableCellAttribute(panelHandle,PANEL_WVTABLE, MakePoint( 1, i+1), ATTR_CTRL_VAL, Data[i].Wv);
	SetTableCellAttribute(panelHandle,PANEL_WVTABLE, MakePoint( 2, i+1), ATTR_CTRL_VAL, Data[i].Order); 
	SetTableCellAttribute(panelHandle,PANEL_WVTABLE, MakePoint( 3, i+1), ATTR_CTRL_VAL, Data[i].Angle); 
	SetTableCellAttribute(panelHandle,PANEL_WVTABLE, MakePoint( 4, i+1), ATTR_CTRL_VAL, Data[i].Step); 
	return 1;
}


int SaveTable(void){
	
	int i;
	float Angle;
	for(i=0;i<nWV_FileIO;i++)
		{
			Angle=(float)(Data[i].Angle);
			GetTableCellAttribute(panelHandle,PANEL_WVTABLE, MakePoint( 1, i+1), ATTR_CTRL_VAL, &(Data[i].Wv)		);
			GetTableCellAttribute(panelHandle,PANEL_WVTABLE, MakePoint( 2, i+1), ATTR_CTRL_VAL, &(Data[i].Order)	); 
			GetTableCellAttribute(panelHandle,PANEL_WVTABLE, MakePoint( 3, i+1), ATTR_CTRL_VAL, &Angle				); 
			GetTableCellAttribute(panelHandle,PANEL_WVTABLE, MakePoint( 4, i+1), ATTR_CTRL_VAL, &(Data[i].Step)		); 
			Data[i].Angle=(double)Angle;
		}
		return 1;
}


int CalculateTable(void){
	int Order, Step;
	float Wv;
	double Angle;
	Point cell;
	GetActiveTableCell(panelHandle, PANEL_WVTABLE, &cell);

		GetTableCellAttribute(panelHandle,PANEL_WVTABLE,MakePoint(1,cell.y),ATTR_CTRL_VAL, &Wv		);
		GetTableCellAttribute(panelHandle,PANEL_WVTABLE,MakePoint(2,cell.y),ATTR_CTRL_VAL, &Order	);  

		AngleStepCalculating(Wv, Order, &Angle, &Step);  	
		SetTableCellAttribute(panelHandle,PANEL_WVTABLE,MakePoint(3,cell.y),ATTR_CTRL_VAL, (float)Angle	);  
		SetTableCellAttribute(panelHandle,PANEL_WVTABLE,MakePoint(4,cell.y),ATTR_CTRL_VAL, Step	);  
	
	return 1;	
}
