#include <userint.h>
#include <ansi_c.h>
#include "WvFunc.h"

//=========================================================================================
//define parameter to read/write wv.ini file

int CurrentSelectWV_FileIO;
int HalphaStep;
int nWV_FileIO;

WvSet Data[50];

//=========================================================================================



//similarity of InitWvRing()
int OpenFileF()
{

	FILE * FP;
	char str[20];
	//nRow returns number of saved wavelength;
	FP=fopen("Wv.ini","rb");
	if(FP==NULL){
		MessagePopup("Error", "Cannot open file Wv.ini");
		fclose(FP);
		return 0;
	}
	else{
		if(ReadHeader(FP))fread(Data, sizeof(WvSet), nWV_FileIO, FP);
		fclose(FP);
		return 1;
	}

}



int ReadHeader(FILE * FP)
{
	int i;
	char WvHeader[2000];
	char strCard[100];
	fread(WvHeader,sizeof(char),2000,FP);
	for(i=0;i<10;i++)
	{
		strncpy(strCard, WvHeader+100*i,100);
		if(strncmp(strCard,		 "NUMBER OF WV    =", 17)==0)sscanf(strCard+17,		"%d",		&nWV_FileIO);
		else if(strncmp(strCard, "CURRENT_SELECT  =", 17)==0)sscanf(strCard+17,		"%d",		&CurrentSelectWV_FileIO);
//		else if(strncmp(strCard, "STARTING POS    =", 17)==0)sscanf(strCard+17,		"%d",		&HalphaStep);
	}

	return 1;
}



int WriteFileF(void)
{
	FILE * FP;

	FP=fopen("Wv.ini","wb");
	if(FP==NULL)
	{
		MessagePopup("Error", "Cannot open file Wv.ini");
		fclose(FP);
		return 0;
	}
	else
	{
		if(WriteHeader(FP))fwrite(Data,sizeof(WvSet), nWV_FileIO, FP);
		fclose(FP);
		return 1;
	}
}



int WriteHeader(FILE * FP)
{
	char WvHeader[2000];
	sprintf(&WvHeader[0],   "NUMBER OF WV    = %d", nWV_FileIO);
	sprintf(&WvHeader[100], "CURRENT_SELECT  = %d", CurrentSelectWV_FileIO);
//	sprintf(&WvHeader[200], "STARTING POS    = %d", HalphaStep);
	//writing Header
	fwrite(WvHeader, sizeof(char), 2000, FP);
	
	return 1;
}



int AngleStepCalculating(float Wvlength1, int order1, double * angle, int * step)
{
	double b=1/79.;
	double theta6562;
	double theta1;

	theta6562=asin(3.4*(6.5628)/2/b*0.001)*180/3.141592;
	
	theta1=asin(order1*Wvlength1*0.0001/2/b*0.001)*180/3.141592;
	*angle=theta1;
	*step=HalphaStep+(theta1-theta6562)*6553.5/3.6+Data[0].Step;
		
	return 1;
}
